--#include "explosion.lua"

	defaults = {
		ModEnabled = true;
		ExplosionSize = 15;
		BreakSize = 5;
		OpenMenu = "n";
		RotateBrushToolClockWise = "h";
		RotateBrushToolCounterClockWise = "g";
		Detonate = "k";
		ShowBrushIndicator = true;
		BrushMode = false; -- Set to false
		DetonateMode = false;
		BrushDiameter = 3;
		ExpandedBrushSteps = false;
		MinimumDistancePlacement = 1;
		DetonatorNotifs = true;
		MaxDistance = 100;
		ToolState = 1; -- Click Needs to be 1
		ToolEffect = 1; -- Explode
		BrushSteps = 5;
		ClickToExplodeTool = 0;
		ExplosiveTimer = 0;
		ExplosiveDelay = -10;
		BrushColor = 1;
		DelayedRaycast = false;
	}


	toolStates = {
		"Click",
		"Hold",
	}

	toolEffects = {
		"Explode",
		"Spawn Fire",
		"Break",
	}
	
	brushColor = {
		{0,255,255,"Cyan"},
		{0,0,255, "Blue"},
		{255,0,255, "Pink"},
		{0,255,0, "Green"},
		{255,0,0, "Red"},
		{255,255,0, "Yellow"},
		{128,0,128, "Purple"},
		{255,165,0, "Orange"},
		{0,0,0, "Black"},
		{255,255,255, "White"}
	}
	
	
	Tools = {
		[0] = "ClickExplodeDoomdrvkTool",
		[1] = "sledge",
		[2] = "spraycan",
		[3] = "extinguisher",
		[4] = "blowtorch",
		[5] = "shotgun",
		[6] = "plank",
		[7] = "pipebomb",
		[8] = "gun",
		[9] = "bomb",
		[10] = "rocket",
	}
	
	ToolNames = { --(Captialized Weapon Names)
		[0] = "Click to Explode Tool",
		[1] = "Sledge",
		[2] = "Spraycan",
		[3] = "Extinguisher",
		[4] = "Blowtorch",
		[5] = "Shotgun",
		[6] = "Plank",
		[7] = "Pipebomb",
		[8] = "Gun",
		[9] = "Bomb",
		[10] = "Rocket",
	}
	
	AcceptableKeys = {
		"a",
		"b",
		"c",
		"d",
		"e",
		"f",
		"g",
		"h",
		"i",
		"j",
		"k",
		"l",
		"m",
		"n",
		"o",
		"p",
		"q",
		"r",
		"s",
		"t",
		"u",
		"v",
		"w",
		"x",
		"y",
		"z",
		"7",
		"8",
		"9",
		"0",
		"return",
		"home",
		"insert",
		"delete",
		"pgup",
		"pgdown",
		"end",
		"uparrow",
		"downarrow",
		"leftarrow",
		"rightarrow",
		"backspace",
		".",
		",",
		"-",
		"+",
		"f1",
		"f2",
		"f3",
		"f4",
		"f5",
		"f6",
		"f7",
		"f8",
		"f9",
		"f10",
		"f11",
	}
	
function init()
	modOptions = "savegame.mod.ClickToExplode"
	RegisterTool("ClickExplodeDoomdrvkTool", "Click To Explode", "MOD/vox/ClickExplode.vox", 3)
	if getModOptions(GetInt, "ClickToExplodeTool") == 0 then
		SetBool("game.tool.ClickExplodeDoomdrvkTool.enabled", true)
	end
	runOptionDefaults(false) 
	if getModOptions(GetInt, "ToolState") == 0 then setModOptions(SetInt, "ToolState", 1) end
	counter = 0
	camChange = 0
	rotateInput = 2
	toolActive = false
	uiActive = false
	uiClosing = false
	UiScaling = 0
	ChangingMenukey = false
	KeyBindBeingChanged = nil
	explosions = {}
	activeExplosives = {}
	activeFires = {}
	activeBreaks = {}
	previousVectors = {}
	brushLines = 1
	timeTable={
		{previousTimer=0, previousDelay=0}, -- Explode
		{previousTimer=0, previousDelay=0}, -- Fire
		{previousTimer=0, previousDelay=0} -- Break
	}
	triggerCountTable = {
		0, -- Explode
		0, -- Fire
		0, -- Break
	}
	--previousTimer = 0
	--previousDelay = 0
	devMode = false
	
	resetTime = -1
	clearFiresTime = -1
	clearExplosivesTime = -1
end

function optionsSlider(current, min, max, incri)
    UiPush()
        UiTranslate(0, -8)
        local steps = incri or 1
        local value = (current - min) / (max - min)
        local width = 100
        UiRect(width, 3)
        UiAlign("center middle")
        value = UiSlider("ui/common/dot.png", "x", value*width, 0, width)/width
        value = math.floor((value*(max-min)+min)/steps+0.5)*steps
    UiPop()
    return value
end

function runOptionDefaults(overWriteDefaultsValues)
	for i,v in pairs(defaults) do
		if not HasKey(modOptions .. "." .. i) or overWriteDefaultsValues then
			local t = type(v)
			local setCall = nil
			if t == "boolean" then
				setCall = SetBool
			elseif t == "number" then
				setCall = SetFloat
			elseif t == "string" then
				setCall = SetString
			end
			setCall(modOptions.."."..i, v)
		end
	end
	if overWriteDefaultsValues == true then
		SetBool("game.tool.ClickExplodeDoomdrvkTool.enabled", false)
	end
end

function getModOptions(GetFunction, Key)
	if  HasKey(modOptions .. "." .. Key) then
		return GetFunction(modOptions .. "." .. Key)
	else
		return nil
	end
end

function setModOptions(SetFunction, Key, value)
	SetFunction(modOptions .. "." .. Key, value)
end

function isKeyValid(key)
	for i,v in ipairs (AcceptableKeys) do
		if v == key then return key end
	end
end

function basicRaycast(pos, dir, maxDist)
	local hit, dist = QueryRaycast(pos, dir, maxDist)
	if hit then
		return VecAdd(pos, VecScale(dir, dist))
	end
end

function activate()
	if getModOptions(GetBool, "DetonatorNotifs") then
		local detString = ""
		if #explosions > 0 then
			if triggerCountTable[1] > 0 then
				detString = detString .. "Detonating " .. triggerCountTable[1] .. " explosives. "
			end
			if triggerCountTable[2] > 0 then
				detString = detString .. "Igniting " .. triggerCountTable[2] .. " fires. "
			end
			if triggerCountTable[3] > 0 then
				detString = detString .. "Breaking " .. triggerCountTable[3] .. " positions."
			end
			SetString("hud.notification", detString)
		end
	end
	for i,v in ipairs (explosions) do
		if v[3] <= 0 then
			if v[4] == 1 then
				if v[5] == true then
					Explosion(basicRaycast(v[1], v[6], v[7]), v[2])
				else
					Explosion(v[1], v[2])
				end
			end
			if v[4] == 2 then
				if v[5] == true then
					SpawnFire(basicRaycast(v[1], v[6], v[7]))
				else
					SpawnFire(v[1])
				end
			end
			if v[4] == 3 then
				if v[5] == true then
					MakeHole(basicRaycast(v[1], v[6], v[7]), v[2], v[2], v[2])
				else
					MakeHole(v[1], v[2], v[2], v[2])
				end
			end
		else
			if v[4] == 1 then
				table.insert(activeExplosives, {v[1], v[2], v[3], v[5], v[6], v[7]})
			elseif v[4] == 2 then
				table.insert(activeFires, {v[1], v[2], v[3], v[5], v[6], v[7]})
			elseif v[4] == 3 then
				table.insert(activeBreaks, {v[1], v[2], v[3], v[5], v[6], v[7]})
			end
			timeTable[v[4]].previousTimer = 0
			timeTable[v[4]].previousDelay = 0
		end
	end
	explosions = {}
	fires={}
	breaks={}
	triggerCountTable={0,0,0}
end

function isToolWithNoAmmo(toolID)
	if toolID == "sledge" or toolID == "spraycan" or toolID == "extinguisher" then return true end
	return false
end

function tick(dt)
	-- Doomdrvk Testing
	if resetTime >= 3 then resetTime = -1 elseif resetTime >= 0 then resetTime = resetTime + dt end
	if clearFiresTime >= 3 then clearFiresTime = -1 elseif clearFiresTime >= 0 then clearFiresTime = clearFiresTime + dt end
	if clearExplosivesTime >= 3 then clearExplosivesTime = -1 elseif clearExplosivesTime >= 0 then clearExplosivesTime = clearExplosivesTime + dt end
	if getModOptions(GetBool, "ModEnabled") == false then return end
	if InputPressed("home") and InputDown("ctrl") and InputDown("shift") then devMode = not devMode end
	
	if #activeExplosives ~= 0 and not GetBool("game.paused") then
		local itemsToRemove = {}
		for i,v in ipairs (activeExplosives) do
			--DebugPrint(activeExplosives[i][3])
			activeExplosives[i][3] = activeExplosives[i][3] - dt
			if activeExplosives[i][3] <= 0 then
				table.insert(itemsToRemove, i)
				if activeExplosives[i][4] == true then
					Explosion(basicRaycast(activeExplosives[i][1], activeExplosives[i][5], activeExplosives[i][6] ), activeExplosives[i][2])
				else
					Explosion(activeExplosives[i][1], activeExplosives[i][2])
				end
			end
		end
		local valueShift = 0
		for i,v in ipairs(itemsToRemove) do
			--DebugPrint(tostring(activeExplosives[v][1]) .. " " ..  tostring(activeExplosives[v][2]) .. " " ..   tostring(activeExplosives[v][3]))
			table.remove(activeExplosives, v+valueShift)
			--DebugPrint(tostring(activeExplosives[v]))
			valueShift = valueShift - 1
		end
	end
	
	if #activeBreaks ~= 0 and not GetBool("game.paused") then
		local itemsToRemove = {}
		for i,v in ipairs (activeBreaks) do
			--DebugPrint(activeExplosives[i][3])
			activeBreaks[i][3] = activeBreaks[i][3] - dt
			if activeBreaks[i][3] <= 0 then
				table.insert(itemsToRemove, i)
				if activeBreaks[i][4] == true then
					MakeHole(basicRaycast(activeBreaks[i][1], activeBreaks[i][5], activeBreaks[i][6]), activeBreaks[i][2], activeBreaks[i][2], activeBreaks[i][2])
				else
					MakeHole(activeBreaks[i][1], activeBreaks[i][2], activeBreaks[i][2], activeBreaks[i][2])
				end
			end
		end
		local valueShift = 0
		for i,v in ipairs(itemsToRemove) do
			--DebugPrint(tostring(activeBreaks[v][1]) .. " " ..  tostring(activeBreaks[v][2]) .. " " ..   tostring(activeBreaks[v][3]))
			table.remove(activeBreaks, v+valueShift)
			--DebugPrint(tostring(activeBreaks[v]))
			valueShift = valueShift - 1
		end
	end
	
	if #activeFires ~= 0 and not GetBool("game.paused") then
		local itemsToRemove = {}
		for i,v in ipairs (activeFires) do
			--DebugPrint(activeExplosives[i][3])
			activeFires[i][3] = activeFires[i][3] - dt
			if activeFires[i][3] <= 0 then
				table.insert(itemsToRemove, i)
				if activeFires[i][4] == true then
					SpawnFire(basicRaycast(activeFires[i][1], activeFires[i][5], activeFires[i][6]))
				else
					SpawnFire(activeFires[i][1])
				end
			end
		end
		local valueShift = 0
		for i,v in ipairs(itemsToRemove) do
			--DebugPrint(tostring(activeFires[v][1]) .. " " ..  tostring(activeFires[v][2]) .. " " ..   tostring(activeFires[v][3]))
			table.remove(activeFires, v+valueShift)
			--DebugPrint(tostring(activeBreaks[v]))
			valueShift = valueShift - 1
		end
	end
	
	
	if InputPressed(getModOptions(GetString, "Detonate")) then activate()  end
	
	local toolState = getModOptions(GetInt, "ToolState")
	local toolEffect = getModOptions(GetInt, "ToolEffect")
	if GetString("game.player.tool") == Tools[getModOptions(GetInt, "ClickToExplodeTool")] and GetPlayerVehicle() == 0 then
		if InputReleased("lmb") then previousVectors = {} end
		local toolActive = (toolState == 1 and InputPressed("lmb")) or (toolState == 2 and InputDown("lmb"))
		local maxDist = getModOptions(GetInt, "MaxDistance")
		if maxDist == 301 then maxDist = 1000 end
		local camTransform = GetCameraTransform()
		local delayedRaycast = getModOptions(GetBool, "DelayedRaycast")
		
		if getModOptions(GetBool, "BrushMode") then
			if InputPressed("rmb") and InputDown("shift") then brushLines = devMode and (brushLines+1<= 15 and brushLines + 1 or 1) or (brushLines+1<= 8 and brushLines + 1 or 1) end
			if rotateInput <= 1 or getModOptions(GetBool, "ShowBrushIndicator") == true or toolActive then
				local brushDiameter, brushSteps = getModOptions(GetFloat, "BrushDiameter"), getModOptions(GetInt, "BrushSteps")
				local color = getModOptions(GetInt, "BrushColor")
				if brushDiameter == 0 then brushDiameter = 0.5 end

				local explosionSize = getModOptions(GetInt, "ExplosionSize")/10
				local explosiveTimer = 0;
				local explosiveDelay = 0;
				local brushRan = false
				
				local previousTracker = 0
				for z = 0, brushLines+1 do
					for i= -brushDiameter/2, brushDiameter/2, brushDiameter/brushSteps do
						previousTracker = previousTracker + 1
						local localSliceTransform = Transform(Vec(0,0,0), QuatEuler(0, 0,  camChange+(180/brushLines*z)))
						local camTransform1 = TransformToParentTransform(camTransform,localSliceTransform)
						local plyTransform = TransformToParentTransform(camTransform1, Transform(Vec(i, 0, 0)))
						local dir = TransformToParentVec(plyTransform, Vec(0,0,-1))
						local hit, dist = QueryRaycast(plyTransform.pos, dir, maxDist)
						if hit or delayedRaycast then
							local hitPos = VecAdd(plyTransform.pos, VecScale(dir, dist))
							if toolActive and not uiActive and not (getModOptions(GetBool, "DetonateMode")) and not delayedRaycast then --and toolEffect == 1) then
							
								if toolEffect == 1 then
									Explosion(hitPos, explosionSize)
								elseif toolEffect == 2 then
									SpawnFire(hitPos)
								elseif toolEffect == 3 then
									local breakSize = getModOptions(GetInt, "BreakSize")/10
									MakeHole(hitPos,breakSize,breakSize,breakSize)
								end
								--DebugLine(VecAdd(plyTransform.pos, Vec(0,-0.5,0)), hitPos)
							elseif getModOptions(GetBool, "DetonateMode") and toolActive and not uiActive then --and toolEffect == 1 or toolEffect==2 then
								local distanceRestriction = getModOptions(GetFloat, "MinimumDistancePlacement")/10
								if #previousVectors == 0 or distanceRestriction == 0 or (VecLength(VecSub(hitPos,previousVectors[previousTracker])) > distanceRestriction) then
									previousVectors[previousTracker] = hitPos
									--SetString("hud.hintinfo", "Beginning " .. previousTimer .. " " .. previousDelay)
									explosiveTimer = getModOptions(GetInt, "ExplosiveTimer")
									explosiveDelay = getModOptions(GetInt, "ExplosiveDelay")
									if explosiveDelay == -12 then
										explosiveDelay = 0
									elseif explosiveDelay == -11 then
										explosiveDelay = 0.005
									elseif explosiveDelay == -10 then
										explosiveDelay = 0.01
									elseif explosiveDelay == -9 then
										explosiveDelay = 0.05
									elseif explosiveDelay < 0 then
										explosiveDelay = 0.9 + explosiveDelay/10
									end
									if timeTable[toolEffect].previousDelay ~= 0 then
										if timeTable[toolEffect].previousTimer ~= 0 then
											explosiveTimer = explosiveTimer + timeTable[toolEffect].previousDelay + timeTable[toolEffect].previousTimer
										else
											explosiveTimer = explosiveTimer + timeTable[toolEffect].previousDelay
										end
									end
									timeTable[toolEffect].previousTimer = explosiveTimer
									timeTable[toolEffect].previousDelay = explosiveDelay
									--brushRan = true
				
									if (toolEffect==3) then
										explosionSize = getModOptions(GetInt, "BreakSize")/10
									end
									hitPos2 = hitPos
									if delayedRaycast then hitPos2 = plyTransform.pos end
									table.insert(explosions, {hitPos2, explosionSize, explosiveTimer, toolEffect, delayedRaycast, dir, maxDist})
									triggerCountTable[toolEffect] = triggerCountTable[toolEffect] + 1
									if getModOptions(GetBool, "DetonatorNotifs") then
										local num = triggerCountTable[toolEffect]
										if toolEffect == 1 then
											SetString("hud.notification", "Explosive Added: " .. num)
										elseif toolEffect == 2 then
											SetString("hud.notification", "Fires Added: " .. num)
										elseif toolEffect == 3 then
											SetString("hud.notification", "Breaks Added: " .. num)
										end
									end
								end
							end
							
							if rotateInput <= 1 or getModOptions(GetBool, "ShowBrushIndicator") == true then
								DebugCross(hitPos, brushColor[color][1]/255, brushColor[color][2]/255, brushColor[color][3]/255, 1)
							end
						end
					end
				end
				--[[if brushRan == true then
					previousTimer = explosiveTimer
					previousDelay = explosiveDelay
					brushRan = false
				end--]]
			end
		else
			local dir = TransformToParentVec(camTransform, Vec(0,0,-1))
			local hit, dist = false, 0
			hit, dist = QueryRaycast(camTransform.pos, dir, maxDist)
			local explosionSize = getModOptions(GetInt, "ExplosionSize")/10
			if hit or delayedRaycast then
				local hitPos = VecAdd(camTransform.pos, VecScale(dir, dist))
				if toolActive and not uiActive and not (getModOptions(GetBool, "DetonateMode")) and not delayedRaycast then --and toolEffect == 1) then
				
					if toolEffect == 1 then
						Explosion(hitPos, explosionSize)
					elseif toolEffect == 2 then
						SpawnFire(hitPos)
					elseif toolEffect == 3 then
						local breakSize = getModOptions(GetInt, "BreakSize")/10
						MakeHole(hitPos,breakSize,breakSize,breakSize)
					end
					--DebugLine(VecAdd(camTransform.pos, Vec(0,-0.5,0)), hitPos)
				elseif getModOptions(GetBool, "DetonateMode") and toolActive and not uiActive then --and toolEffect == 1 then
					local distanceRestriction = getModOptions(GetFloat, "MinimumDistancePlacement")/10
					if #previousVectors == 0 or distanceRestriction == 0 or (VecLength(VecSub(hitPos,previousVectors[1])) > distanceRestriction) then
						previousVectors[1] = hitPos
						--SetString("hud.hintinfo", "Beginning " .. previousTimer .. " " .. previousDelay)
						
						explosiveTimer = getModOptions(GetInt, "ExplosiveTimer")
						explosiveDelay = getModOptions(GetInt, "ExplosiveDelay")
						if explosiveDelay == -12 then
							explosiveDelay = 0
						elseif explosiveDelay == -11 then
							explosiveDelay = 0.005
						elseif explosiveDelay == -10 then
							explosiveDelay = 0.01
						elseif explosiveDelay == -9 then
							explosiveDelay = 0.05
						elseif explosiveDelay < 0 then
							explosiveDelay = 0.9 + explosiveDelay/10
						end
						if previousDelay ~= 0 then
							if previousTimer ~= 0 then
								explosiveTimer = explosiveTimer + timeTable[toolEffect].previousTimer + timeTable[toolEffect].previousDelay
							else
								explosiveTimer = explosiveTimer + timeTable[toolEffect].previousDelay
							end
						end
										
						timeTable[toolEffect].previousTimer = explosiveTimer
						timeTable[toolEffect].previousDelay = explosiveDelay
						
						if (toolEffect==3) then
							explosionSize = getModOptions(GetInt, "BreakSize")/10
						end
						if delayedRaycast then hitPos = camTransform.pos end
						table.insert(explosions, {hitPos, explosionSize, explosiveTimer, toolEffect, delayedRaycast, dir, maxDist})
						triggerCountTable[toolEffect] = triggerCountTable[toolEffect] + 1
						if getModOptions(GetBool, "DetonatorNotifs") then
							local num = triggerCountTable[toolEffect]
							if toolEffect == 1 then
								SetString("hud.notification", "Explosive Added: " .. num)
							elseif toolEffect == 2 then
								SetString("hud.notification", "Fires Added: " .. num)
							elseif toolEffect == 3 then
								SetString("hud.notification", "Breaks Added: " .. num)
							end
						end
					end
				end
			end
		end
	end
	
	if not getModOptions(GetBool, "BrushMode") then return end 
    rotateInput = InputDown(getModOptions(GetString, "RotateBrushToolCounterClockWise")) and 0 or InputDown(getModOptions(GetString,"RotateBrushToolClockWise")) and 1 or 2
    if rotateInput == 2 then return end
	local speed = 80
	if InputDown("shift") then speed = (devMode and InputDown("mmb")) and 160 or 120 elseif InputDown("alt") then speed = (devMode and InputDown("mmb")) and 20 or 40 end
	--DebugWatch("Speed", speed)
    if rotateInput == 0 then camChange = camChange + (1 * speed * dt)
    else camChange = camChange - (1 * speed * dt) end
    if camChange >= 360 then camChange = 0
    elseif camChange <= 0 then camChange = 360 end
end



--Configuration UI
function draw()
	local toolIndex = getModOptions(GetInt, "ClickToExplodeTool")
	if ((GetString("game.player.tool") == Tools[toolIndex] and getModOptions(GetBool, "ModEnabled") == true) or GetString("game.player.tool") == Tools[0]) and uiActive == false then
		UiPush()
			local height = UiHeight()*0.93
			--SetInt("game.tool."..GetString("game.player.tool")..".ammo", 9990)
			--DebugWatch("Ammo", GetInt("game.tool.".. GetString("game.player.tool")..".ammo"))
			if (isToolWithNoAmmo(GetString("game.player.tool"))) or GetInt("game.tool."..GetString("game.player.tool")..".ammo") >= 9990 then height = UiHeight()*0.96 end
			UiTranslate(UiCenter()+5, height)
			UiTextOutline(0,0,0,1)
			UiColor(141/255, 28/255, 5/255)
			UiFont('bold.ttf', 20)
			UiAlign('center middle')
			UiText("Menu (".. string.upper(getModOptions(GetString, "OpenMenu")).. ")")
			if getModOptions(GetBool, "BrushMode") and brushLines > 1 then
				UiTranslate(0,-17)
				UiText("Brush Lines: " .. brushLines)
			end
		UiPop()
	end
	if InputPressed(getModOptions(GetString, "OpenMenu")) then
		uiActive = not uiActive
		if uiActive then
			SetValue("UiScaling", 1, "easeout", 0.25)
		end
	end
	if uiActive == true or uiClosing == true then
		UiMakeInteractive()
		UiModalBegin()
		UiButtonHoverColor(214/255, 214/255, 214/255)
		SetBool("game.disablepause", true)
		SetBool("game.disablemap", true)
		UiSound("common/options-off.ogg")
		UiPush()
			UiFont("regular.ttf", 26)

			UiColorFilter(1,1,1,UiScaling)
			
			UiTranslate(UiCenter(), UiMiddle())
			UiAlign("center middle")
			UiScale(UiScaling)
			UiWindow(740, 820)
			UiAlign("top left")
			UiColor(.0, .0, .0, 0.7)
			UiImageBox("ui/common/box-solid-shadow-50.png", 740, 820, -50, -50)
			if (InputPressed("esc") and not KeyBindBeingChanged) or (InputPressed(getModOptions(GetString, "OpenMenu")) and not ChangingMenukey) or (not UiIsMouseInRect(740, 820) and InputPressed("lmb")) then
				uiClosing = true
				SetValue("UiScaling", 0, "easeout", 0.25)
			end
			UiPush()
				UiFont("regular.ttf", 50)
				UiAlign("center")
				UiTranslate(UiCenter(), 50)
				UiColor(230/255, 99/255, 0/255)
				UiText("Click to Explode")
			UiPop()
			
			UiTranslate(0, 110)
			
			local x1 = 10
			local lh = 28
			
			UiTranslate(390, 0)
			UiAlign("right")
			UiColor(1,1,1)
			UiPush()
				UiText("Mod Enabled")
				UiTranslate(x1, 0)
				UiAlign("left")
				local val = getModOptions(GetBool,"ModEnabled")
				if val == false then
					UiColor(252/255, 30/255, 30/255)
					if UiTextButton("Disabled") then
						setModOptions(SetBool, "ModEnabled", true)
					end
				else
					UiColor(0, 209/255, 53/255)
					if UiTextButton("Enabled") then
						setModOptions(SetBool, "ModEnabled", false)
					end
				end
			UiPop()
			
			UiTranslate(0, lh)
			
			UiPush()
				UiText("Click to Explode Tool")
				UiTranslate(x1, 0)
				UiAlign("left")
				local tool = getModOptions(GetInt, "ClickToExplodeTool")
				local current = optionsSlider(tool, 0, #Tools, 1)
				if current ~= tool then
					setModOptions(SetInt, "ClickToExplodeTool", current)
					if current == 0 then SetBool("game.tool.ClickExplodeDoomdrvkTool.enabled", true) else SetBool("game.tool.ClickExplodeDoomdrvkTool.enabled", false) end
					previousVector = {}
				end
				UiTranslate(120, 0)
				UiText(ToolNames[current])
			UiPop()
			
			UiTranslate(0, lh)
			
			UiPush()
				UiText("Max Distance")
				UiTranslate(x1, 0)
				UiAlign("left")
				local maxDistance = getModOptions(GetInt, "MaxDistance")
				local current = optionsSlider(maxDistance, 1, 301, 1)
				if current ~= maxDistance then
					setModOptions(SetInt, "MaxDistance", current)
					previousVector = {}
				end
				UiTranslate(120, 0)
				UiText(current ~= 301 and current or "INF")
			UiPop()	
			
			UiTranslate(0, lh)
			
			UiPush()
				UiText("Tool Effect")
				UiTranslate(x1, 0)
				UiAlign("left")
				local current = getModOptions(GetInt, "ToolEffect")
				if UiTextButton(toolEffects[current]) then
					setModOptions(SetInt, "ToolEffect", current+1 > #toolEffects and 1 or current+1)
				end
			UiPop()
			
			UiTranslate(0, lh)
			
			local effect = getModOptions(GetInt, "ToolEffect")
			UiPush()
				if effect == 1 then
					UiText("Explosion Size")
					UiTranslate(x1, 0)
					UiAlign("left")
				elseif effect == 3 then
					UiText("Break Size")
					UiTranslate(x1, 0)
					UiAlign("left")
				end
				local current = nil
				if effect == 1 then
					local explosionSize = getModOptions(GetInt, "ExplosionSize")
					local current = optionsSlider(explosionSize, 5, 40, 1)
					if current ~= explosionSize then
						setModOptions(SetInt, "ExplosionSize", current)
					end
					UiTranslate(120, 0)
					UiText(current/10)
					
				elseif effect == 2 then
					UiTranslate(0, -lh)
				elseif effect == 3 then
					local breakSize = getModOptions(GetInt, "BreakSize")
					local current = optionsSlider(breakSize, 1, 50, 1)
					if current ~= breakSize then
						setModOptions(SetInt, "BreakSize", current)
					end
					setModOptions(SetInt, "BreakSize", current)
					UiTranslate(120, 0)
					UiText(current/10)
				end
			UiPop()
			
			if effect ~= 2 then
				UiTranslate(0, lh)
			end
			if true then --effect ~= 2 then
				if true then--effect == 1 then
					local remote = getModOptions(GetBool, "DetonateMode")
					UiPush()
						UiText("Remote Triggering")
						UiTranslate(x1, 0)
						UiAlign("left")
						if remote == false then
							if UiTextButton("Disabled") then
								setModOptions(SetBool, "DetonateMode", true)
								previousVectors = {}
							end
						else
							if UiTextButton("Enabled") then
								setModOptions(SetBool, "DetonateMode", false)
								previousVectors = {}
							end
						end
					UiPop()
										
					UiTranslate(0, lh)
					if remote == true then
						UiPush()
							UiText("Remote Notifications")
							UiTranslate(x1, 0)
							UiAlign("left")
							local current = getModOptions(GetBool,"DetonatorNotifs")
							if current == false then
								if UiTextButton("Disabled") then
									setModOptions(SetBool, "DetonatorNotifs", true)
								end
							else
								if UiTextButton("Enabled") then
									setModOptions(SetBool, "DetonatorNotifs", false)
								end
							end
						UiPop()
						
						UiTranslate(0, lh)
						
						UiPush()
							UiText("Delayed Raycast")
							UiTranslate(x1, 0)
							UiAlign("left")
							local current = getModOptions(GetBool,"DelayedRaycast")
							if current == false then
								if UiTextButton("Disabled") then
									setModOptions(SetBool, "DelayedRaycast", true)
								end
							else
								if UiTextButton("Enabled") then
									setModOptions(SetBool, "DelayedRaycast", false)
								end
							end
						UiPop()
						
						UiTranslate(0, lh)
						
						UiPush()
							UiText("Remote Trigger Timer")
							UiTranslate(x1, 0)
							UiAlign("left")
							local timer = getModOptions(GetInt, "ExplosiveTimer")
							local current = optionsSlider(timer, 0, 60, 1)
							if current ~= timer then
								setModOptions(SetInt, "ExplosiveTimer", current)
							end
							UiTranslate(120, 0)
							local secondsText = " seconds"
							local uiValue = tostring(current)
							if current == 0 then
								uiValue = "Off"
								secondsText = ""
							elseif current == 1 then
								secondsText = " second"
							end
							
							UiText(uiValue .. secondsText)
						UiPop()
						
						UiTranslate(0, lh)
						
						UiPush()
							UiText("Delay Between Triggering")
							UiTranslate(x1, 0)
							UiAlign("left")
							local explosionDelay = getModOptions(GetInt, "ExplosiveDelay")
							local current = optionsSlider(explosionDelay, -12, 60, 1)
							if current ~= explosionDelay then
								setModOptions(SetInt, "ExplosiveDelay", current)
							end
							UiTranslate(120, 0)
							local secondsText = " Seconds"
							local uiValue = tostring(current)
							if current == -12 then
								uiValue = "Off"
								secondsText = ""
							elseif current == -11 then
								uiValue = 5
								secondsText = " Milliseconds"
							elseif current == -10 then
								uiValue = 10
								secondsText = " Milliseconds"
							elseif current == -9 then
								uiValue = 50
								secondsText = " Milliseconds"
							elseif current <= 0 then
								uiValue = (0.9 + current/10) * 1000
								secondsText = " Milliseconds"
							elseif current == 1  then
								secondsText = " Second"
							end
							
							UiText(uiValue .. secondsText)
						UiPop()
						
						UiTranslate(0, lh)
						
						UiPush()
							UiText("Minimun Place Distance")
							UiTranslate(x1, 0)
							UiAlign("left")
							local minPlacement = getModOptions(GetInt, "MinimumDistancePlacement")
							local current = optionsSlider(minPlacement, 0, 100, 1)
							if current ~= minPlacement then
								setModOptions(SetInt, "MinimumDistancePlacement", current)
							end
							UiTranslate(120, 0)
							UiText(current == 0 and "0 - Laggy!" or current/10)
						UiPop()
						
						UiTranslate(0, lh)
					end
				end
			end
			
			
			UiPush()
				UiText("Tool Activation")
				UiTranslate(x1, 0)
				UiAlign("left")
				local current = getModOptions(GetInt, "ToolState")
				if UiTextButton(toolStates[current]) then
					setModOptions(SetInt, "ToolState", current+1 > #toolStates and 1 or current+1)
				end
			UiPop()
			
			UiTranslate(0, lh)
			
			local brushMode = getModOptions(GetBool,"BrushMode")
			UiPush()
				UiText("Brush Mode")
				UiTranslate(x1, 0)
				UiAlign("left")
				if brushMode == false then
					if UiTextButton("Disabled") then
						setModOptions(SetBool, "BrushMode", true)
						previousVectors = {}
					end
				else
					if UiTextButton("Enabled") then
						setModOptions(SetBool, "BrushMode", false)
						previousVectors = {}
					end
				end
			UiPop()
			
			 if brushMode == true then
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Brush Line Indicator")
					UiTranslate(x1, 0)
					UiAlign("left")
					local val = getModOptions(GetBool,"ShowBrushIndicator")
					if val == false then
						if UiTextButton("Disabled") then
							setModOptions(SetBool, "ShowBrushIndicator", true)
						end
					else
						if UiTextButton("Enabled") then
							setModOptions(SetBool, "ShowBrushIndicator", false)
						end
					end
					UiPush()
						local color = getModOptions(GetInt, "BrushColor")
						UiTranslate(120, 0)
						UiColor(brushColor[color][1]/255, brushColor[color][2]/255, brushColor[color][3]/255, 1)
						if UiTextButton(brushColor[color][4]) then
							setModOptions(SetInt, "BrushColor", color+1 <= #brushColor and color+1 or 1)
						end
					UiPop()
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Brush Diameter")
					UiTranslate(x1, 0)
					UiAlign("left")
					local diameter = getModOptions(GetInt, "BrushDiameter")
					local current = optionsSlider(diameter, 0, 100, 1)
					if current ~= diameter then
						setModOptions(SetInt, "BrushDiameter", current)
					end
					UiTranslate(120, 0)
					UiText(current ~= 0 and current or 0.5)
				UiPop()
				
				UiTranslate(0, lh)
				
				local expandedBrushSteps = getModOptions(GetBool,"ExpandedBrushSteps")
				UiPush()
					UiText("Expanded Brush Steps")
					UiTranslate(x1, 0)
					UiAlign("left")
					if expandedBrushSteps == false then
						if UiTextButton("Disabled") then
							setModOptions(SetBool, "ExpandedBrushSteps", true)
						end
					else
						if UiTextButton("Enabled") then
							setModOptions(SetBool, "ExpandedBrushSteps", false)
							setModOptions(SetInt, "BrushSteps", math.min(getModOptions(GetInt, "BrushSteps"), 30))
						end
					end
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Brush Steps")
					UiTranslate(x1, 0)
					UiAlign("left")
					local steps = getModOptions(GetInt, "BrushSteps")
					local current = optionsSlider(steps, 1, expandedBrushSteps and 500 or 30, 1)
					if current ~= steps then
						setModOptions(SetInt, "BrushSteps", current)
						previousVector = {}
					end
					UiTranslate(120, 0)
					UiText(current .. "*")
				UiPop()
			end
			
			UiTranslate(0, lh)
			
			UiPush()
				UiTranslate(0, 30)
				UiPush()
					UiFont("bold.ttf", 50)
					UiAlign("center middle")
					--UiColor(0, 0, 0)
					UiText("Keybinds")
				UiPop()
				UiTranslate(0, lh+15)
				UiAlign("right")
				UiPush()
					UiText("Open Menu")
					UiTranslate(x1, 0)
					UiAlign("left")
					local currentKeybind = getModOptions(GetString, "OpenMenu")
					local currentText = ""
					if KeyBindBeingChanged == "OpenMenu" then
						local lastInput = string.lower(InputLastPressedKey())
						currentText = "..."
						if isKeyValid(lastInput) then
							setModOptions(SetString, "OpenMenu", lastInput)
							KeyBindBeingChanged = nil
							currentText = lastInput
							ChangingMenukey = false
						elseif lastInput == "esc" then
							KeyBindBeingChanged = nil
							currentText = string.upper(currentKeybind)
							ChangingMenukey = false
						end
					else
						currentText = currentKeybind
					end
					if UiTextButton(string.upper(currentText)) then
						--if KeyBindBeingChanged == nil then
							KeyBindBeingChanged = "OpenMenu"
							ChangingMenukey = true
						--end
					end
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Trigger")
					UiTranslate(x1, 0)
					UiAlign("left")
					local currentKeybind = getModOptions(GetString, "Detonate")
					local currentText = ""
					if KeyBindBeingChanged == "Detonate" then
						local lastInput = string.lower(InputLastPressedKey())
						currentText = "..."
						if isKeyValid(lastInput) then
							setModOptions(SetString, "Detonate", lastInput)
							KeyBindBeingChanged = nil
							currentText = string.upper(lastInput)
							ChangingMenukey = false
						elseif lastInput == "esc" then
							KeyBindBeingChanged = nil
							setModOptions(SetString, "Detonate", "_")
							currentText = string.upper("_")
							currentText = string.upper(currentKeybind)
							ChangingMenukey = false
						end
					else
						currentText = string.upper(currentKeybind)
					end
					if UiTextButton(currentText) then
						--if KeyBindBeingChanged == nil then
							KeyBindBeingChanged = "Detonate"
							ChangingMenukey = true
						--end
					end
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Rotate Brush CW")
					UiTranslate(x1, 0)
					UiAlign("left")
					local currentKeybind = getModOptions(GetString, "RotateBrushToolClockWise")
					local currentText = ""
					if KeyBindBeingChanged == "RotateBrushToolClockWise" then
						local lastInput = string.lower(InputLastPressedKey())
						currentText = "..."
						if isKeyValid(lastInput) then
							setModOptions(SetString, "RotateBrushToolClockWise", lastInput)
							KeyBindBeingChanged = nil
							currentText = string.upper(lastInput)
							ChangingMenukey = false
						elseif lastInput == "esc" then
							KeyBindBeingChanged = nil
							setModOptions(SetString, "RotateBrushToolClockWise", "_")
							currentText = "_"
							ChangingMenukey = false
						end
					else
						currentText = string.upper(currentKeybind)
					end
					if UiTextButton(currentText) then
						--if KeyBindBeingChanged == nil then
							KeyBindBeingChanged = "RotateBrushToolClockWise"
							ChangingMenukey = true
						--end
					end
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiText("Rotate Brush CCW")
					UiTranslate(x1, 0)
					UiAlign("left")
					local currentKeybind = getModOptions(GetString, "RotateBrushToolCounterClockWise")
					local currentText = ""
					if KeyBindBeingChanged == "RotateBrushToolCounterClockWise" then
						local lastInput = string.lower(InputLastPressedKey())
						currentText = "..."
						if isKeyValid(lastInput) then
							setModOptions(SetString, "RotateBrushToolCounterClockWise", lastInput)
							KeyBindBeingChanged = nil
							currentText = string.upper(lastInput)
							ChangingMenukey = false
						elseif lastInput == "esc" then
							KeyBindBeingChanged = nil
							setModOptions(SetString, "RotateBrushToolCounterClockWise", "_")
							currentText = "_"
							ChangingMenukey = false
						end
					else
						currentText = string.upper(currentKeybind)
					end
					if UiTextButton(currentText) then
						--if KeyBindBeingChanged == nil then
							KeyBindBeingChanged = "RotateBrushToolCounterClockWise"
							ChangingMenukey = true
						--end
					end
				UiPop()
				
				UiTranslate(0, lh)
				
				UiPush()
					UiTranslate(0, 10)
					UiPush()
						UiTranslate(-130,0)
						UiFont("bold.ttf", 20)
						UiAlign("right middle")
						if UiTextButton(clearFiresTime < 0 and "Clear All Fires" or "Clear All Fires**") then
							if clearFiresTime < 0 then
								clearFiresTime = 0
							else
								clearFiresTime = -1
								SetString("hud.notification", "Removing " .. GetFireCount() .. " fires." .. (#activeFires > 0 and " Removing " .. #activeFires .. " active remote fires." or ""))
								activeFires = {}
								RemoveAabbFires(Vec(-10000, -10000, -10000), Vec(10000, 10000, 10000))
							end
						end
					UiPop()
					UiPush()
						UiFont("bold.ttf", 26)
						UiAlign("center middle")
						--UiColor(0, 0, 0)
						if UiTextButton( resetTime < 0 and "Reset All To Default" or "Reset All To Default**") then
							if resetTime < 0 then
								resetTime = 0
							else
								runOptionDefaults(true)
								KeyBindBeingChanged = nil
								resetTime = -1
							end
						end
						UiFont("bold.ttf", 20)
						UiAlign("left middle")
						UiTranslate(x1+120, 0)
						if UiTextButton(clearExplosivesTime < 0 and "Clear All Remote Triggers" or "Clear All Remote Triggers**") then
							if clearExplosivesTime < 0 then
								clearExplosivesTime = 0
							else
								local removeString = ""
								if #explosions + #activeExplosives+#activeFires+#activeBreaks > 0 then
									if #explosions > 0 then
										removeString = removeString .. "Removing " .. #explosions .. " remote triggers."
									end
									if #activeExplosives+#activeFires+#activeBreaks>0 then
										removeString = removeString .. (#explosions > 0 and "\nRemoving " or "Removing ") .. #activeExplosives+#activeFires+#activeBreaks .. " active triggers."
									end
								else
									removeString = "No remote triggers found."
								end
								SetString("hud.notification", removeString)
								activeExplosives = {}
								activeFires={}
								activeBreaks = {}
								explosions = {}
								triggerCountTable = {0,0,0}
								clearExplosivesTime = -1
							end
						end
					UiPop()
				UiPop()
			UiPop()
			
		UiPop()
		
		if UiScaling == 0 and uiClosing == true then
			uiActive = false
			uiClosing = false
			ChangingMenukey = false
			SetBool("game.disablepause", false)
			SetBool("game.disablemap", false)
			SetBool("level.ingame-menu-open", false)
		end
	end
end


